﻿using System;
using System.IO;

public class UploadUtil
{
    /// <summary>
    /// 경로 + 파일명 => 해당 경로에 해당 파일이 있으면 파일명(번호).확장자 반환
    /// </summary>
    /// <param name="strBaseDirTemp">경로</param>
    /// <param name="strFileNameTemp">파일명</param>
    /// <returns>파일명(번호).확장자 반환</returns>
    public static string GetFilePath(string strBaseDirTemp, string strFileNameTemp)
    {
        string strName = //순수파일명 : Test
            Path.GetFileNameWithoutExtension(strFileNameTemp); //[1] 순수 파일명만 반환
        string strExt =		// 확장자 : .txt
            Path.GetExtension(strFileNameTemp); //[2] 순수 확장자만 : . 포함
        bool blnExists = true;
        int i = 0;
        while (blnExists)
        {
            //[3] Path.Combine(경로, 파일명) = 경로 + 파일명
            if (File.Exists(Path.Combine(strBaseDirTemp, strFileNameTemp)))
            {
                strFileNameTemp =
                  strName + "(" + ++i + ")" + strExt; // Test(3).txt
            }
            else
            {
                blnExists = false;
            }
        }
        return strFileNameTemp;
    }
}
