﻿using System;
using System.Web.UI.WebControls;

public partial class Upload_View : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (String.IsNullOrEmpty(Request["Num"]))
        {
            Response.Write("잘못된 요청");
            Response.End();
        }
        else
        {
            if (!Page.IsPostBack)
            {
                DisplayData();
            }
        }
    }
    private void DisplayData()
    {
        UploadEntity ue = new UploadEntity();
        UploadBiz ub = new UploadBiz();
        ue = ub.ViewUpload(Convert.ToInt32(Request["Num"])); 

        // 각각의 컨트롤에 바인딩
        lblNum.Text = Request["Num"];
        lblName.Text = ue.Name;
        lblEmail.Text = ue.Email;
        lblTitle.Text = ue.Title;
        lblHomepage.Text = ue.Homepage;
        lblPostDate.Text = ue.PostDate.ToString();
        lblReadCount.Text = ue.ReadCount.ToString();
        lblPostIP.Text = ue.PostIP;

        // 인코딩에 따른 내용 표시
        string content = ""; 
        if (ue.Encoding.ToLower() == "text") // Text : 입력한 소스 그대로 화면에 출력
        {
            content = ue.Content.Replace("&", "&amp;").Replace("<", "&lt;")
                .Replace(">", "&gt;").Replace("\r\n", "<br />")
                    .Replace("\t", "&nbsp;&nbsp;&nbsp;&nbsp;");
        }
        else if (ue.Encoding.ToLower() == "mixed") // Mixed : 태그처리 + 엔터처리
        {
            content = ue.Content.Replace("\r\n", "<br />"); 
        }
        else
        {
            content = ue.Content; // HTML : 태그처리
        }
        lblContent.Text = content; 

        //[1] 
        lblFileName.Text = String.Format("<a href='Down.aspx?FileName={0}'>{0}</a> / 다운수 : {1}"
            , ue.FileName, ue.DownCount);
        //[2] 
        lnkFileName.Text = ue.FileName;
        lnkFileName.NavigateUrl = String.Format("~/Upload/Down.aspx?FileName={0}", ue.FileName);
        //[3]
        //[a] 동적으로 하이퍼링크를 만들어서
        HyperLink lnk = new HyperLink();
        lnk.Text = ue.FileName.ToString();
        lnk.NavigateUrl = String.Format("~/Upload/Down.aspx?FileName={0}", ue.FileName);
        //[b] 플레이스홀더 컨트롤에 추가
        ctlFileName.Controls.Add(lnk);
    }
    protected void btnModify_Click(object sender, EventArgs e)
    {
        // 수정 페이지로 이동
        Response.Redirect("Modify.aspx?Num=" + Request["Num"]); 
    }
}
